/*
    Project: TCGINA
    Version: V1.25
    File   : misc.h

    Copyright (c) 2005-2008 Author of TCGINA DLL. All rights reserved.
    Public Key Fingerprint: 294B A769 4A0A CC05 DAE6 00DD FF47 8C72 4097 67CE

    Covered by TrueCrypt License 2.3 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the public key
    fingerprint must be retained in full.
*/

#ifndef __MISC_H_D47DF546F16B490bA6D8523603A5594D
#define __MISC_H_D47DF546F16B490bA6D8523603A5594D

#ifndef countof
#  define countof(arr) (sizeof(arr)/sizeof((arr)[0]))
#endif

#ifdef _WIN64
#  define SetWindowUserData(hWnd, dwNewLong) \
     SetWindowLongPtr(hWnd, GWLP_USERDATA, (LONG_PTR)dwNewLong)
#  define GetWindowUserData(hWnd) \
     GetWindowLongPtr(hWnd, GWLP_USERDATA)
#else
#  define SetWindowUserData(hWnd, dwNewLong) \
     SetWindowLongPtr(hWnd, GWLP_USERDATA, PtrToLong(dwNewLong))
#  define GetWindowUserData(hWnd) \
     LongToPtr(GetWindowLongPtr(hWnd, GWLP_USERDATA))
#endif

#define ConvertUnicodeToAnsi(paszDest, cbSize, pwszSrc) \
  WideCharToMultiByte(CP_ACP, 0, pwszSrc, -1, paszDest, cbSize, NULL, NULL)
#define ConvertAnsiToUnicode(pwszDest, cchSize, paszSrc) \
  MultiByteToWideChar(CP_ACP, 0, paszSrc, -1, pwszDest, cchSize)

#ifdef UNICODE
#  define CopyString(pszDest, cchSize, pszSrc) \
     CopyStringW(pszDest, cchSize, pszSrc)
#  define AppendString(pszDest, cchSize, pszSrc) \
     AppendStringW(pszDest, cchSize, pszSrc)
#  define CopyStringToAnsi(paszDest, cchSize, pszSrc) \
     ConvertUnicodeToAnsi(paszDest, cchSize, pszSrc)
#  define CopyStringToUnicode(pwszDest, cchSize, pszSrc) \
     CopyString(pwszDest, cchSize, pszSrc)
#  define CopyStringFromAnsi(pszDest, cchSize, paszSrc) \
     ConvertAnsiToUnicode(pszDest, cchSize, paszSrc)
#define CopyStringFromUnicode(pszDest, cchSize, pwszSrc) \
     CopyString(pszDest, cchSize, pwszSrc)
#else
#  define CopyString(pszDest, cchSize, pszSrc) \
     CopyStringA(pszDest, cchSize, pszSrc)
#  define AppendString(pszDest, cchSize, pszSrc) \
     AppendStringA(pszDest, cchSize, pszSrc)
#  define CopyStringToAnsi(paszDest, cchSize, pszSrc) \
     CopyString(paszDest, cchSize, pszSrc)
#  define CopyStringToUnicode(pwszDest, cchSize, pszSrc) \
     ConvertAnsiToUnicode(pwszDest, cchSize, pszSrc)
#  define CopyStringFromAnsi(pszDest, cchSize, paszSrc) \
     CopyString(pszDest, cchSize, paszSrc)
#  define CopyStringFromUnicode(pszDest, cchSize, pwszSrc) \
     ConvertUnicodeToAnsi(pszDest, cchSize, pwszSrc)
#endif

#ifdef __cplusplus
extern "C" {
#endif

BOOL CopyStringA(LPSTR paszDest, size_t cchSize, LPCSTR paszSrc);
BOOL CopyStringW(LPWSTR pwszDest, size_t cchSize, LPCWSTR pwszSrc);
BOOL AppendStringA(LPSTR pszDest, size_t cchSize, LPCSTR pszSrc);
BOOL AppendStringW(LPWSTR pszDest, size_t cchSize, LPCWSTR pszSrc);

#ifdef __cplusplus
}
#endif

#endif
